// To compile:
// 	dfl dfldll1 dlltest.def


private import dfl.all, dfl.internal.winapi;


private extern(C)
{
	void gc_init();
	void gc_term();
	void _minit();
	void _moduleCtor();
	void _moduleUnitTests();
}


export extern(C) void doit()
{
	with(new Form)
	{
		text = "DLL 1";
		show();
	}
}


extern(Windows) BOOL DllMain(HINSTANCE hInstance, ULONG ulReason, LPVOID pvReserved)
{
	try
	{
		switch(ulReason)
		{
			case DLL_PROCESS_ATTACH:
				gc_init(); // Initialize GC.
				_minit(); // Initialize module list.
				Application.setInstance(hInstance); // Before user code but after initializing D.
				_moduleCtor(); // Run module constructors.
				_moduleUnitTests(); // Run module unit tests.
				break;
			
			case DLL_PROCESS_DETACH:
				gc_term(); // Shut down GC.
				break;
			
			case DLL_THREAD_ATTACH:
			case DLL_THREAD_DETACH:
				return false; // No multiple threads.
			
			default: ;
		}
		return true;
	}
	catch(Object o)
	{
		msgBox(o.toString(), "DLL 1 ERROR");
		return false;
	}
}

